"use strict";
this.name               = "sothis_tc";
this.author               = "spara";
this.copyright            = "2013 Mika Spåra";
this.description         = "Add SothisTC to high tech corporate states";
this.version            = "1.0.3";
this.licence     = "CC BY-NC-SA 3.0";

this.startUp = function() {
	if (!worldScripts.CargoTypeExtension) { //check for new cargoes oxp
		this.$new_cargoes = false;
		delete this.playerBoughtEquipment;
		delete this.shipLaunchedFromStation;
	}
	else {
		this.$tc_eqTradenet = false;
		this.$new_cargoes = true;
	}
	if(!worldScripts["Spawn-sothis"]) { //check for sothis station oxp
		delete this.systemWillPopulate;
		delete this.$addSothis;
		delete this.shipDockedWithStation;
		delete this.playerBoughtEquipment;
		delete this.shipLaunchedFromStation;
		player.consoleMessage("Sothis OXP is not installed, exiting SothisTC.", 5);
		log("SothisTC","Sothis OXP is not installed, exiting SothisTC.");
	}
	else {
		delete worldScripts["Spawn-sothis"].shipWillExitWitchspace;
	}
	this.$showWelcome = false;
}

this.systemWillPopulate = function()  {
	this.$addSothis();
} 

this.$addSothis = function() { //add sothis to corporate states
	//Ask spawn permission from Station Validator oxp
	if (worldScripts.station_validator && (worldScripts.station_validator.$deaths("sothis").length !== 0))
		return;	
	if (system.government == 7 && system.techLevel > 7 && system.mainStation) {
		var a = system.mainStation.position.x;
		var b = system.mainStation.position.y;
		var c = 1.5*system.mainStation.position.distanceTo(system.mainPlanet);
		var x = - b * c / Math.sqrt(b * b + a * a);
		var y = a * c / Math.sqrt(b * b + a * a);
		var z = system.mainStation.position.z;
				var exactPosition = [x, y, z];
		system.setPopulator("sothis_tc", {
			callback: function(pos) {			
				system.addShips("sothis", 1, pos, 0);					
			}.bind(this),
			location: "COORDINATES",
			coordinates: exactPosition,
			deterministic: true
		})

	}
}

this.shipDockedWithStation = function(station) { //give special welcome screen when docking sothis
	if (station.hasRole("sothis")){
		this.$showWelcome = true;
		if (this.$new_cargoes) { //give access to tradenet when visiting sothis
			if (player.ship.equipmentStatus("EQ_CTE_TRADERNET") != "EQUIPMENT_OK") {
				this.$tc_eqTradenet = false;
				player.ship.awardEquipment("EQ_CTE_TRADERNET");
				missionVariables.cargotypeextension_tradernet = clock.days + 30;
			}
			else 
				this.$tc_eqTradenet = true;
		}
	}
}

this.missionScreenOpportunity= function() {
	if (!this.$showWelcome) return;
	var messText = expandDescription("[STC_welcome]");
	if (this.$new_cargoes)
		messText = messText + expandDescription("[STC_new_cargoes]");	
	var tcbgpic = "OOmap_G"+(galaxyNumber+1)+".png";
	mission.runScreen({
		title: "Sothis Trade Center",
		message: messText,
		background: tcbgpic
	});
	this.$showWelcome = false;
}

this.playerBoughtEquipment = function(equipment) { //check for tradenet
	if (equipment == "EQ_CTE_TRADERNET")
		this.$tc_eqTradenet = true;
	else if (equipment == "EQ_CTE_TRADERNET_RENEWAL")
		this.$tc_eqTradenet = true;
}

this.shipLaunchedFromStation = function(station) { //remove tradenet on launch from sothis if not bought
	if (this.$new_cargoes && station.hasRole("sothis")){
		if (!this.$tc_eqTradenet) {
			player.ship.removeEquipment("EQ_CTE_TRADERNET");
			delete missionVariables.cargotypeextension_tradernet;
		}
	}
}
